
function AddEvent(a_Object, a_Event, a_Function)
{
  l_Event = a_Event.toLowerCase();
  var l_OldEvent = a_Object[l_Event];
  if (typeof a_Object[l_Event] != 'function')
  {
    a_Object[l_Event] = a_Function;
  }
  else
  {
    a_Object[l_Event] = function()
    {
      if (l_OldEvent)
      {
        l_OldEvent();
      }
      a_Function();
    }
  }
}

function AddOnLoadEvent(a_Function)
{
  if(!window.onLoadEventList)
  {
    window.onLoadEventList = new Array();
  }
  window.onLoadEventList.push(a_Function)
}

function OnLoadEvent()
{
  var l_List = window.onLoadEventList;
  if(l_List)
  {
    for(var i=0 ; i<l_List.length ; i++)
    {
      l_List[i]();
    }
  }
}

window.onload = OnLoadEvent;



function AddOnUnloadEvent(a_Function)
{
  if(!window.onUnloadEventList)
  {
    window.onUnloadEventList = new Array();
  }
  window.onUnloadEventList.push(a_Function)
}

function OnUnloadEvent()
{
  var l_List = window.onUnloadEventList;
  if(l_List)
  {
    for(var i=0 ; i<l_List.length ; i++)
    {
      l_List[i]();
    }
  }
}

window.onunload = OnUnloadEvent;



function AddOnMouseMoveEvent(a_Function)
{
  if(!window.onMouseMoveEventList)
  {
    window.onMouseMoveEventList = new Array();
  }
  window.onMouseMoveEventList.push(a_Function)
}

function OnMouseMoveEvent(a_Event)
{
  var l_List = window.onMouseMoveEventList;
  if(l_List)
  {
    for(var i=0 ; i<l_List.length ; i++)
    {
      l_List[i](a_Event);
    }
  }
}

if(navigator.appName.substring(0,3) == "Net")
{
	document.captureEvents(Event.MOUSEMOVE);
}

document.onmousemove = OnMouseMoveEvent;

