unit fonctions_xml;

{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

interface

uses
  Classes, SysUtils,
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  ALXmlDoc, controls,
  DB,
  fonctions_manbase,
  Forms;
type
  TCreateFromXML           = (cxMainOnly,cxCreateDS,cxRecurseTables,cxTemplateClass,cxDoubleColumn,cxFieldFound,cxIsRelation);
  TDoCreateFromXML         = set of TCreateFromXML;

  TOnExecuteNode = procedure ( const ADBSources : TFWTables;  const ADBSource : TFWTable; const ANodeParent : TALXMLNode ; var ANode : TALXMLNode ; var AFormCreate : TDoCreateFromXML; var ai_FieldCounter : Longint );
  TOnExecuteFieldNode = procedure ( const ADBSources : TFWTables;
                                    const ADBSource  : TFWTable;
                                    const ANodeParent, ANode : TALXMLNode ;
                                    var ANodeImport : TALXMLNode ;
                                    var   adoc_ClassImport : TALXMLDocument ;
                                    var   afcFormCreating : TDoCreateFromXML ;
                                    var   ai_Fieldcounter : Longint );

  TOnExecuteActionNode = procedure ( const ADBSources : TFWTables;
                                    const ADBSource  : TFWTable;
                                    const ANodeParent : TALXMLNode ;
                                    var   afcFormCreating : TDoCreateFromXML );

  // XML parameters
  var gs_ProjectFile  : String;
      gs_RootEntities : String ;
      gNod_DashBoard  : TALXMLNode = nil;
      gNod_Classes    : TALXMLNode = nil;
      gNod_RootAction : TALXMLNode = nil;
      gxdo_FichierXML : TALXMLDocument = nil;// Lecture de Document du projet   initialisé  au create
      gxdo_MenuXML    : TALXMLDocument = nil;// Lecture de Document du menu   initialisé  au create
      gxdo_RootXML    : TALXMLDocument = nil;// Lecture de Document des entités   initialisé  au create
      gs_entities     : String  = 'rootEntities' ;
      gs_LeonardiSubDir : String = '';
      gb_DataHasXML     : Boolean = True;

const CST_LEON_File_Extension = '.xml';
      {$IFDEF VERSIONS}
        gver_fonctions_XML : T_Version = ( Component : 'Librairie de fonctions XML' ;
                                           FileUnit : 'fonctions_xml' ;
                    			                 Owner : 'Matthieu Giroux' ;
                    			                 Comment : 'XML Form and SQL creating Functions. No XML Form in this unit.' + #13#10 +
                                                                 'Il ne doit pas y avoir de lien vers les objets à créer.' ;
                    			                 BugsStory :'Version 1.0.2.0 : Import Field.' + #13#10 +
                                                                    'Version 1.0.1.0 : Parameters.' + #13#10 +
                                                                    'Version 1.0.0.0 : Tenplates.' + #13#10 +
                                                                    'Version 0.9.9.0 : centralising SQL Creating functions.' + #13#10 +
                                                                    'Version 0.9.0.2 : centralising searching on xml nodes.' + #13#10 +
                                                                    'Version 0.9.0.1 : Images Directory.' + #13#10 +
                                                                    'Version 0.9.0.0 : Unit functionnal.' + #13#10 +
                                                                    'Version 0.1.0.0 : Création de l''unité.';
                    			                 UnitType : 1 ;
                    			                 Major : 1 ; Minor : 0 ; Release : 2 ; Build : 0 );

      {$ENDIF}

      CST_LEON_DATA_FILE     = 'L_FILE' ;
      CST_LEON_DATA_SQL      = 'L_SQL' ;

      CST_LEON_DUMMY = 'DUMMY' ;
      CST_LEON_PROJECT = 'PROJECT' ;
      CST_LEON_ROOT_ACTION = 'rootAction' ;
      CST_LEON_ROOT_ACTION_ID = 'id' ;
      CST_LEON_CLASS = 'CLASS' ;
      CST_LEON_BOOL_FALSE = 'false' ;
      CST_LEON_BOOL_TRUE  = 'true' ;

      CST_LEON_NAME_BEGIN     = 'NAME_' ;
      CST_LEON_LOCATION = 'location';
      CST_LEON_IDREF = 'idref';
      CST_LEON_VALUE = 'value';
      CST_LEON_BEHAVIOR = 'behavior';
      CST_LEON_NAME  = 'NAME' ;
      CST_LEON_VIEW  = 'view' ;

      CST_LEON_PASSWORD_INFO = '_passwordFieldInfo' ;
      CST_LEON_LOGIN_INFO    = '_loginFieldInfo' ;
      CST_LEON_USER_CLASS    = '_userClassInfo' ;

      CST_LEON_ROOT            = 'ROOT';
      CST_LEON_SYSTEM_ROOT     = 'ROOT SYSTEM';
      CST_LEON_SYSTEM          = 'SYSTEM';
      CST_LEON_LOCATION_SYSTEM = 'LOCATION SYSTEM';
      CST_LEON_SYSTEM_LEON     = 'LEON';
      CST_LEON_SYSTEM_NAVIGATION = 'NAVIGATION SYSTEM';

      CST_LEON_DIR           = '$LY_APP_DIR$';
      CST_LEON_DOC           = '$LY_APP_DOC$';
      CST_LEON_DOC_DIR       = '$LY_APP_DOC_DIR$';
      CST_LEON_DIRECTORY     = 'directory';
      CST_LEON_MIMETYPES     = 'mimeTypes';
      CST_LEON_MIME_IMAGE    = 'image';
      CST_IMAGES_DIR         = 'images/';

      CST_LEON_FIELD_LOCAL    = 'local' ;

      CST_LEON_FIELDS = 'FIELDS' ;
      CST_LEON_FIELD_id = 'id' ;
      CST_LEON_FIELD_TIP   = 'TIP' ;
      CST_LEON_FIELD_NCOLS = 'NCOLS' ;
      CST_LEON_FIELD_NCHARS= 'NCHARS' ;
      CST_LEON_FIELD_MIN   = 'MIN' ;
      CST_LEON_FIELD_MAX   = 'MAX' ;
      CST_LEON_FIELD_PITCH = 'PITCH' ;
      CST_LEON_FIELD_NROWS = 'NROWS' ;

      CST_LEON_IDREFs = 'idrefs';
      CST_LEON_CLASS_REF    = 'CLASS_REF';
      CST_LEON_CLASSES      = 'CLASSES';
      CST_LEON_CLASS_C_BIND   = 'C_BIND';
      CST_LEON_CLASS_CBIND    = 'cbind';
      CST_LEON_CLASS_C_MARKS  = 'C_MARKS' ;

      CST_LEON_CHOICE_OPTIONS = 'OPTIONS' ;
      CST_LEON_CHOICE_OPTION  = 'OPTION' ;
      CST_LEON_RULE_OPTION    = 'RULE' ;
      CST_LEON_RULE_OPERATION = 'operation' ;
      CST_LEON_RULE_EDITABLE  = 'SET_EDITABLE' ;
      CST_LEON_RULE_READONLY  = 'SET_READONLY' ;
      CST_LEON_RULE_OPTIONAL  = 'SET_OPTIONAL' ;
      CST_LEON_RULE_NEEDED    = 'SET_NEEDED' ;
      CST_LEON_RULE_ONCHECK   = 'onCheck' ;
      CST_LEON_RULE_VALUE     = 'value' ;
      CST_LEON_RULE_SETVALUE  = 'SET_VALUE' ;
      CST_LEON_RULE_ENABLED   = 'SET_ENABLED' ;
      CST_LEON_RULE_DISABLED  = 'SET_DISABLED' ;
      CST_LEON_RULE_CLEAR     = 'CLEAR' ;
      CST_LEON_OPTION_NAME    = 'name' ;
      CST_LEON_OPTION_VALUE   = 'value' ;
      CST_LEON_OPTION_DEFAULT = 'default' ;

      CST_LEON_FIELD_NUMBER   = 'NUMBER' ;
      CST_LEON_FIELD_TYPE     = 'type' ;
      CST_LEON_FIELD_COMPOSITION = 'COMPOSITION' ;
      CST_LEON_FIELD_DOUBLE   = 'DOUBLE' ;
      CST_LEON_FIELD_DECIMALS = 'DECIMALS' ;
      CST_LEON_FIELD_FORMULA  = 'FORMULA' ;
      CST_LEON_FIELD_DATE     = 'DATE' ;
      CST_LEON_FIELD_TEXT     = 'TEXT' ;
      CST_LEON_FIELD_CHOICE   = 'CHOICE' ;
      CST_LEON_FIELD_FILE     = 'FILE' ;
      CST_LEON_STRUCT         = 'STRUCT' ;
      CST_LEON_ARRAY          = 'ARRAY' ;

      CST_LEON_RELATION       = 'RELATION' ;
      CST_LEON_RELATION_REVERSE= 'REVERSE' ;
      CST_LEON_REVERSE_RELATION='reverseRelation';
      CST_LEON_RELATION_JOIN  = 'JOIN_DAEMON' ;

      CST_LEON_FIELDS_DEF  : array [0..6] of string = (CST_LEON_FIELD_NUMBER,CST_LEON_FIELD_DATE,CST_LEON_RELATION,CST_LEON_FIELD_TEXT,CST_LEON_FIELD_CHOICE,CST_LEON_FIELD_FILE,CST_LEON_STRUCT);


      CST_LEON_FIELD_IMPORT   = 'IMPORT' ;
      CST_LEON_FIELD_RELATION = 'relation' ;
      CST_LEON_FIELD_NOCONTEXT= 'noContext' ;
      CST_LEON_FIELD_F_MARKS  = 'F_MARKS' ;
      CST_LEON_FIELD_F_BIND   = 'F_BIND' ;
      CST_LEON_FIELD_C_BIND   = 'C_BIND' ;
      CST_LEON_FIELD_CREATE   = 'create' ;
      CST_LEON_FIELD_PROVIDER = 'providerValue' ;
      CST_LEON_FIELD_DEFAULT  = 'N_DEFAULT' ;
      CST_LEON_FIELD_UNIQUE   = 'unique' ;
      CST_LEON_FIELD_HIDDEN   = 'hidden' ;
      CST_LEON_FIELD_private  = 'private' ;
      CST_LEON_FIELD_optional = 'optional' ;
      CST_LEON_FIELD_set      = 'set' ;
      CST_LEON_FIELD_main     = 'main' ;
      CST_LEON_FIELD_sort     = 'sort' ;
      CST_LEON_FIELD_find     = 'find' ;
      CST_LEON_FIELD_filter   = 'filter' ;

      CST_LEON_GROUP = 'GROUP' ;
      CST_LEON_TAB   = 'TAB' ;

      CST_LEON_TEMPLATE = 'template' ;
      CST_LEON_TEMPLATE_DASHBOARD = '_dashboard' ;
      CST_LEON_TEMPLATE_LOGIN = '_login' ;
      CST_LEON_ID    = 'id' ;

      CST_LEON_PARAMETER = 'PARAMETER';
      CST_LEON_PARAMETER_NAME = 'name' ;
      CST_LEON_PARAMETER_URL  = '_url' ;
      CST_LEON_PARAMETER_VALUE = 'value' ;
      CST_LEON_PARAMETER_IDREF = 'idref' ;
      CST_LEON_PARAMETER_CLASSINFO = '_classInfo' ;

      CST_LEON_TEMPLATE_MULTIPAGETABLE = '_multiPageTable' ;
      CST_LEON_ACTION_NAME = 'NAME' ;
      CST_LEON_ACTION_TEMPLATE = 'template' ;
      CST_LEON_ACTION = 'ACTION' ;
      CST_LEON_ACTIONS = 'ACTIONS' ;
      CST_LEON_ACTION_REF = 'ACTION_REF' ;
      CST_LEON_ACTION_PREFIX = 'PREFIX' ;
      CST_LEON_ACTION_CLASSINFO = '_classInfo' ;
      CST_LEON_ACTION_VALUE = 'value' ;
      CST_LEON_ACTION_IDREF = 'idref' ;
      CST_LEON_ACTION_REF_DELETE = '_delete' ;
      CST_LEON_ACTION_REF_PRINT = '_print' ;
      CST_LEON_ACTION_REF_ADD    = '_add' ;
      CST_LEON_ACTION_REF_SET    = '_set' ;
      CST_LEON_ACTION_REF_CLONE  = '_clone' ;

      CST_LEON_COMPOUND_ACTION = 'COMPOUND_ACTION' ;
      CST_LEON_ENTITY = '!ENTITY ';

      CST_XMLFRAMES_ROOT_FORM_CLEP = 'rootentitie' ;

      CST_COMBO_FIELD_SEPARATOR    = ',' ;

function fb_LoadXMLFile ( const axdo_FichierXML : TALXMLDocument; const as_FileXML : String ): Boolean;
function fs_getLeonDir :String ;
function fs_getLeonDataXML : String;
function fs_getLeonData : String;
function fs_getLeonDoc : String;
function fs_getLeonInfo : String;
function fs_getLeonFiles : String;
function fs_getImagesDir : String;
function fs_getProjectDir : String;
function fs_LeonFilter ( const AString : String ): String;
function fb_GetMarkFunction(const anod_Field :TALXMLNode ; const as_MarkSearched : String ; const aff_FieldNodes : TFWMiniFieldColumns ):Boolean;
procedure p_CountMarkFunction(const anod_Field :TALXMLNode ; const as_MarkSearched : String ; const ab_IsTrue : Boolean;  var ai_Count : Integer );
function fb_GetCrossLinkNode( const as_ParentClass: String ; const anod_FieldProperties :TALXMLNode ): Boolean ;
function fs_GetNodeAttribute( const anod_Node : TALXMLNode ; const as_Attribute : String ) : String ;
function fnod_GetClassFromRelation( const anod_Node : TALXMLNode ) : TALXMLNode ;
function fnod_GetNodeFromTemplate( const anod_Node : TALXMLNode ) : TALXMLNode ;

function fs_GetIdAttribute ( const anode : TALXMLNode ) : String;
function fb_getFieldOptions ( const afws_Sources : TFWTables;
                              const afws_Source : TFWTable;
                              const anod_Fields : TALXMLNode;
                              const anod_Field  : TALXMLNode ;
                              var   anod_FieldImport : TALXMLNode ;
                              var   adoc_ClassTemplate,adoc_ClassImport : TALXMLDocument ;
                              const anod_FieldProperties : TALXMLNode ;
                              const affd_ColumnFieldDef : TFWFieldColumn;
                              const acom_Owner : TComponent;
                              const ab_isReference : Boolean = True ;
                              const ab_MainOnly : Boolean = False ;
                              const ab_FullTable : Boolean = False ): Boolean;
function fb_getOptionalStructTable ( const afwt_Sources : TFWTables;
                                     const afwt_Source : TFWTable;
                                     var   afwt_Source2 : TFWTable;
                                     var   ac_FormCreate : TDoCreateFromXML ;
                                     var   ai_Fieldcounter : Longint  ;
                                     const affd_ColumnFieldDef : TFWFieldColumn;
                                     const anod_Field,anod_OriginalNode : TALXMLNode;
                                     const ab_createDS : Boolean; const ab_AddLinks : Boolean = True): Boolean;
function fb_getOptionalStructTableBegin ( const afwt_Sources : TFWTables;
                                     const afwt_Source : TFWTable;
                                     var   afwt_Source2 : TFWTable;
                                     var   afc_FormCreating : TDoCreateFromXML ;
                                     var   ai_Fieldcounter : Longint  ;
                                     const affd_ColumnFieldDef : TFWFieldColumn;
                                     const anod_Class,anod_OriginalNode : TALXMLNode;
                                     const ab_createDS : Boolean; const ab_AddLinks : Boolean = True): Boolean;
procedure p_CreateStructTable( const afwt_Sources : TFWTables; const aft_Table : TFWTable;
                               const affd_ColumnFieldDef  : TFWFieldColumn;
                               var acx_FormCreate : TDoCreateFromXML ;
                               var   ai_Fieldcounter : Longint  );
function  fb_setFieldType ( const afws_Sources : TFWTables ;
                            const afws_Source : TFWTable ;
                            const af_FieldDef : TFWFieldColumn;
                            const anod_Fields : TALXMLNode;
                            const anod_Field : TALXMLNode;
                            var   anod_FieldImport : TALXMLNode;
                            var   as_Group, as_tab : String;
                            var   adoc_ClassTemplate,adoc_ClassImport : TALXMLDocument ;
                            const ai_counter : Integer;
                            var   acx_CreateFromXML : TDoCreateFromXML;
                            const ab_FullTable : Boolean;
                            const acom_Owner : TComponent;
                            const ab_isreference : Boolean=True;
                            const ab_passIfNotId : Boolean = False;
                            const as_fieldname   : String = ''): Boolean;
function fb_setNodeField ( const anod_Field : TALXMLNode;
                           const affd_ColumnFieldDef : TFWMiniFieldColumn;
                           var   acx_FormCreate : TDoCreateFromXML;
                           const ab_isreference : Boolean = True;
                           const ab_idref : Boolean = True;
                           const ab_Templates : Boolean = False):Boolean;
procedure p_setNodesField ( const anod_FieldProperty : TALXMLNode;
                            const affd_ColumnFieldDef : TFWMiniFieldColumn;
                            const ab_isreference : Boolean = True);
function fb_getNodesField ( const anod_FieldProperty : TALXMLNode;
                            const ab_isreference : Boolean = True):Boolean;
procedure p_setNodeId ( const anod_FieldIsId : TALXMLNode;
                        const afws_Source : TFWTable ;
                        const affd_ColumnFieldDef : TFWMiniFieldColumn  );
procedure p_FieldIsNotAKey( const affd_ColumnFieldDef : TFWFieldColumn);
procedure p_OnCreateFieldProperties ( const ADBSources : TFWTables; const ADBSource : TFWTable;
                                      const anod_Fields, anod_Field: TALXMLNode;
                                      var   anod_FieldImport: TALXMLNode;
                                      var   adoc_ClassImport : TALXMLDocument ;
                                      var   afc_FormCreating : TDoCreateFromXML ;
                                      var   ai_Fieldcounter : Longint );
function fb_OpenClass ( const as_XMLClass : String ; const acom_owner : TComponent ;
                        var axml_SourceFile : TALXMLDocument ):Boolean;
function fb_createFieldID ( const ab_IsSourceTable : Boolean; const anod_Field: TALXMLNode ;
                            const affd_ColumnFieldDef : TFWFieldColumn;
                            var   acx_CreateFromXML : TDoCreateFromXML;
                            const ai_Fieldcounter : Integer ;
                            const ab_Templates : Boolean = False):Boolean;
procedure p_FindAndSetSourceKey ( const as_Class, as_FieldExternalKey : String ;
                                  const afws_Sources : TFWTables ;
                                  const afws_Source : TFWTable ;
                                  const acom_owner : TComponent ;
                                  const ach_FieldDelimiter : Char );
procedure p_SetFieldSelect ( const affd_ColumnFieldDef : TFWFieldColumn; const act_ComponentType : TComponentType  );
function ft_CreateComponents ( const ADBSources : TFWTables ; const as_XMLClass, as_Name : String ;
                               var   axml_Class : TALXMLDocument ;
                               const acom_owner : TComponent;
                               const ae_OnFieldNode : TOnExecuteFieldNode ;
                               const ae_onActionNode : TOnExecuteActionNode ;
                               const ae_onClassNameNode : TOnExecuteNode;
                               const acx_CreateFromXML : TDoCreateFromXML=[cxCreateDS];
                               const ab_ContinueIfLocal : Boolean = False;
                               const as_SearchedClass : String = ''):TFWTable;
function fnod_FindField      ( const as_XMLClass : String ;
                               const acom_owner : TComponent;
                               var   axml_Class : TALXMLDocument ;
                               const as_SearchedField : String ):TALXMLNode;
function fnod_GetFieldNode ( const axml_Class : TALXMLDocument ;
                             var   anod_Fields : TALXMLNode;
                             const as_SearchedNode : String):TALXMLNode; overload;
function fnod_GetFieldNode ( const anod_Fields : TALXMLNode;
                             const as_SearchedNode : String):TALXMLNode; overload;
function ff_GetTemplateField ( const afws_ATables : TFWTables;
                               const afws_ATable : TFWTable;
                               const as_FieldName : String;
                               const anod_Fields, anod_Field: TALXMLNode;
                               var  anod_Template : TALXMLNode ) : TFWFieldColumn;
function fnod_GetFieldNode ( const axml_Root : TALXMLDocument;
                             const as_SearchedNode : String):TALXMLNode; overload;
function fb_GetCrossLinkFunction( const ADBSources : TFWTables ;
                                  const ADBSource : TFWTable ;
                                  const Aff_field : TFWFieldColumn ;
                                  const as_FunctionClep :String;
                                        as_Table : String; const arel_Relation : TFWRelation;
                                  const acx_CreateFromXML : TDoCreateFromXML;
                                  const acom_Owner : TComponent ): Boolean ;
function fb_FieldTypeProperties ( const afws_Source : TFWTable ;
                                  var   afr_Relation : TFWRelation;
                                  var   ata_tableRelation : TFWTable ;
                                  var   as_FieldLink, as_Group, as_tab : String;
                                  const anod_Field,anod_FieldProperties : TALXMLNode;
                                  const af_FieldDef : TFWFieldColumn; var ab_islarge : Boolean;
                                  var   as_formula  : String;
                                  const acx_createFromXML: TDoCreateFromXML;
                                  const ab_FullTable : Boolean;
                                  const acom_Owner : TComponent):Boolean;
function fs_GetDBClassLink ( anod_FieldClassId : TALXMLNode ) : String;

implementation

uses fonctions_ini,
{$IFDEF FPC}
     LazFileUtils,
{$ELSE}
     Variants, StrUtils,
{$ENDIF}
     fonctions_proprietes,
     fonctions_dbservice,
     ExtCtrls,
     u_multidata,
     u_multidonnees,
     fonctions_string,
     fonctions_dialogs,
     fonctions_system,
     DbCtrls;

function fs_getLeonDir :String ;
Begin
  if ( gs_LeonardiSubDir = '' )
  or ( gs_LeonardiSubDir [ 1 ] = '.' )
   Then Result:=GetAppDir+gs_LeonardiSubDir
   Else Result:=gs_LeonardiSubDir;
end;


// function fb_createFieldID
// create and init a field from XML
function fb_createFieldID ( const ab_IsSourceTable : Boolean; const anod_Field: TALXMLNode ;
                            const affd_ColumnFieldDef : TFWFieldColumn;
                            var   acx_CreateFromXML : TDoCreateFromXML;
                            const ai_Fieldcounter : Integer ;
                            const ab_Templates : Boolean = False):Boolean;
Begin
  Result := fb_setNodeField(anod_Field,affd_ColumnFieldDef,acx_CreateFromXML,True,True,ab_Templates);
  if result Then
    with affd_ColumnFieldDef do
      begin
        IsSourceTable := ab_IsSourceTable;
        NumTag      := ai_Fieldcounter + 1;
        ShowSearch  := -1;
        ColSelect:=False;
      end;
end;

// function fb_OpenClass
// Opens a class file from class name
// Returns true if ok
function fb_OpenClass ( const as_XMLClass : String ; const acom_owner : TComponent ;
                        var axml_SourceFile : TALXMLDocument ):Boolean;
var ls_ProjectFile : String ;
begin
  Result := False;
  if not assigned ( axml_SourceFile ) Then
    axml_SourceFile := TALXMLDocument.Create ( acom_owner );
  ls_ProjectFile := fs_getProjectDir ( ) + as_XMLClass + CST_LEON_File_Extension;
  // For actions at the end of xml file
  If ( FileExistsUTF8 ( ls_ProjectFile )) Then
   // reading the special XML form File
    try
      if fb_LoadXMLFile ( axml_SourceFile, ls_ProjectFile ) Then
         Result := True;
    Except
      On E: Exception do
        Begin
          MyShowMessage ( 'Erreur opening XML Class File : ' + E.Message );
        End;
    End ;

end;


procedure p_FieldIsNotAKey( const affd_ColumnFieldDef : TFWFieldColumn);
Begin
  with affd_ColumnFieldDef do
    Begin
      ColUnique:=False;
      ColHidden:=False;
      ColPrivate:=False;
    End;
End;
// procedure p_CreateArrayStructComponents
// Creating groupbox with controls
function fb_CreateArrayStructComponents ( const ADBSources : TFWTables; const ADBSource : TFWTable;
                                          const affd_ColumnFieldDef : TFWFieldColumn;
                                          const anod_Field: TALXMLNode;
                                          var   afc_FormCreating : TDoCreateFromXML ;
                                          var   ai_Fieldcounter : Longint  ): Boolean;
var li_k, li_l, li_FieldCounter : LongInt ;
    lb_column : Boolean;
    lfwt_Source2 : TFWTable;
    lnod_FieldsNode,lnod_FieldsNodeImport,lnod_FieldsChildNode : TALXmlNode;
    ldoc_ClassImport : TALXMLDocument ;
    lb_relation  : Boolean;
    lct_ComponentType  : TComponentType;
    lnod_OriginalNode : TALXmlNode;
    ls_class : String;
    lwin_last : TWinControl;
begin
  Result := True;
  lct_ComponentType := ctDB;
  lnod_OriginalNode := fnod_GetNodeFromTemplate(anod_Field);
  lfwt_Source2 := nil;
  if anod_Field <> lnod_OriginalNode Then
    Begin
     Result := fb_getOptionalStructTableBegin ( ADBSources,ADBSource,lfwt_Source2,afc_FormCreating,ai_Fieldcounter,affd_ColumnFieldDef,anod_Field,lnod_OriginalNode, False );
     if not Result Then
       Exit;
    end;

  li_FieldCounter := 0 ;
  lwin_last := nil;
  ls_class := '';
  ldoc_ClassImport := nil;
  if lnod_OriginalNode.HasChildNodes then
    for li_k := 0 to lnod_OriginalNode.ChildNodes.Count - 1 do
      Begin
        lnod_FieldsNode := lnod_OriginalNode.ChildNodes [ li_k ];
        if lnod_FieldsNode.NodeName = CST_LEON_NAME then
            Continue;
        if (   lnod_OriginalNode.NodeName = CST_LEON_STRUCT )
        and lnod_OriginalNode.ChildNodes [ li_k ].HasChildNodes then
          Begin
            lb_column := False;
            if lnod_FieldsNode.NodeName = CST_LEON_FIELDS Then
              Begin
                for li_l := 0 to lnod_FieldsNode.ChildNodes.Count - 1 do
                  Begin
                    lnod_FieldsChildNode := lnod_FieldsNode.ChildNodes [ li_l ];
                    if anod_Field = lnod_OriginalNode Then
                        p_OnCreateFieldProperties ( ADBSources, ADBSource,
                                                  lnod_FieldsNode,lnod_FieldsChildNode,
                                                  lnod_FieldsNodeImport,
                                                  ldoc_ClassImport,
                                                  afc_FormCreating,
                                                  ai_Fieldcounter)
                      else
                        p_OnCreateFieldProperties ( ADBSources, lfwt_Source2,
                                                    lnod_FieldsNode, lnod_FieldsChildNode,
                                                    lnod_FieldsNodeImport,
                                                    ldoc_ClassImport,
                                                    afc_FormCreating,
                                                    li_FieldCounter);
                    FreeAndNil(ldoc_ClassImport);
                  end;
              end
             Else
              // The parent parameter is a var : so do not want to change it in the function
              if anod_Field = lnod_OriginalNode Then
                  p_OnCreateFieldProperties ( ADBSources, ADBSource,
                                            lnod_FieldsNode, lnod_FieldsNode,
                                            lnod_FieldsNodeImport,
                                            ldoc_ClassImport,
                                            afc_FormCreating,
                                            ai_FieldCounter)
               else
                 p_OnCreateFieldProperties ( ADBSources, lfwt_Source2,
                                          lnod_FieldsNode, lnod_FieldsNode,
                                          lnod_FieldsNodeImport,
                                          ldoc_ClassImport,
                                          afc_FormCreating,
                                          li_FieldCounter);
           FreeAndNil(ldoc_ClassImport);
           lct_ComponentType:=ctLocal;
          end;
      end;
  if assigned ( affd_ColumnFieldDef ) Then
   Begin
    if anod_Field <> lnod_OriginalNode Then
      affd_ColumnFieldDef.Assign(lfwt_Source2.FieldsDefs.FieldByName(lfwt_Source2.GetKey.Items [0].FieldName));
    p_SetFieldSelect( affd_ColumnFieldDef, lct_ComponentType);
   end;
end;

// procedure p_OnCreateFieldProperties
// Creating the column components
// as_Table : Table Name
// anod_Field: Node field
// ai_FieldCounter : Field counter
//  ai_Counter : Column counter
// awin_Parent : Parent component
// ab_Column : Second editing column
// afws_Source : XML form Column
// afd_FieldsDefs : Field Definitions
procedure p_OnCreateFieldProperties ( const ADBSources : TFWTables; const ADBSource : TFWTable;
                                      const anod_Fields, anod_Field: TALXMLNode;
                                      var   anod_FieldImport: TALXMLNode;
                                      var   adoc_ClassImport : TALXMLDocument ;
                                      var   afc_FormCreating : TDoCreateFromXML;
                                      var   ai_Fieldcounter : Longint);
var lb_IsLocal  : Boolean;
    lcx_FormCreate : TDoCreateFromXML;
    lffd_ColumnFieldDef : TFWFieldColumn;
    ldoc_ClassTemplate : TALXMLDocument;
    lnod_OriginalNode : TALXmlNode;
    ls_group, ls_tab : String;
    li_i : LongInt ;

begin
  lcx_FormCreate:=afc_FormCreating-[cxTemplateClass];
  if    anod_Field.HasAttribute(CST_LEON_FIELD_TYPE)  // compositions are not yet supported
  and ( anod_Field.Attributes[CST_LEON_FIELD_TYPE] = CST_LEON_FIELD_COMPOSITION ) Then
    Exit;
  afc_FormCreating := afc_FormCreating - [cxDoubleColumn];
  // Creating the properties and setting data link

   lffd_ColumnFieldDef := ADBSource.FieldsDefs.Add;
   if ( anod_Field.NodeName = CST_LEON_STRUCT )
   and fb_CreateArrayStructComponents(ADBSources, ADBSource, lffd_ColumnFieldDef, anod_Field,
                                      afc_FormCreating, ai_Fieldcounter )
    Then
     Begin
       fb_setNodeField (anod_Field,lffd_ColumnFieldDef,lcx_FormCreate);
       p_FieldIsNotAKey( lffd_ColumnFieldDef );
       // Quitting because having created properties
       Exit;
     end;
   ldoc_ClassTemplate := nil;
   li_i := 0;
   if not fb_createFieldID ( True, anod_Field, lffd_ColumnFieldDef, lcx_FormCreate ,ai_Fieldcounter )
   or (cxTemplateClass in lcx_FormCreate )
   or fb_setFieldType(ADBSources,ADBSource,lffd_ColumnFieldDef,anod_Fields,anod_Field,anod_FieldImport,ls_group, ls_tab,ldoc_ClassTemplate,adoc_ClassImport,li_i,afc_FormCreating,True,nil,True,False)
    Then  ADBSource.FieldsDefs.Delete(lffd_ColumnFieldDef.Index)
    Else inc ( ai_Fieldcounter );
   FreeAndNil(ldoc_ClassTemplate);
end;


////////////////////////////////////////////////////////////////////////////////
// function fdoc_GetCrossLinkFunction
// Getting over side link of relationships
// as_FunctionClep    : String
// as_Table           : Table name and class name
// as_connection      : connect link key
// aanod_idRelation   : List to add link
// anod_NodeCrossLink : linked node in other file
////////////////////////////////////////////////////////////////////////////////
function fb_GetCrossLinkFunction( const ADBSources : TFWTables ;
                                  const ADBSource : TFWTable ;
                                  const Aff_field : TFWFieldColumn ;
                                  const as_FunctionClep :String;
                                        as_Table : String; const arel_Relation : TFWRelation;
                                  const acx_CreateFromXML : TDoCreateFromXML;
                                  const acom_Owner : TComponent ): Boolean ;
var li_i , li_j : Integer ;
    lnod_ClassProperties, lnod_import, lnod_id : TALXMLNode ;
    lnod_Node, lnod_NodeCrossLink : TALXMLNode;
    ls_ProjectFile,ls_group, ls_tab ,
    ls_table       ,
    ls_temp        : String;
    li_FullFields ,
    li_CountFields : Integer;
    lds_Connection : TDSSource;
    lb_Column,
    lb_Relation,
    lb_fieldfound : Boolean;
    ldoc_ClassTemplate,
    ldoc_ClassImport : TALXMLDocument;
    lfwt_Source,lfwt_Source2 : TFWTable;
    laxd_Document :TALXMLDocument;
     procedure p_SetFields;
     var lfc_DoFormCreate : TDoCreateFromXML;
         li_k : Integer;
      Begin
        lfc_DoFormCreate:=acx_CreateFromXML-[cxDoubleColumn,cxFieldFound,cxTemplateClass];
        li_CountFields := 0 ;
        li_FullFields:=0;
        with arel_Relation do
        for li_k := 0 to lnod_ClassProperties.ChildNodes.Count -1 do
          Begin
            lnod_id := lnod_ClassProperties.ChildNodes [ li_k ];
            ldoc_ClassTemplate := nil;
            ldoc_ClassImport := nil;
            if Assigned(lfwt_Source2) Then
             Begin  // create every tables if demanded
              lb_fieldfound := True;
              p_OnCreateFieldProperties(ADBSources,lfwt_Source2,lnod_ClassProperties,lnod_id,lnod_import,ldoc_ClassImport,lfc_DoFormCreate,li_FullFields);
             End;
            lb_Relation:=False;
            if fb_GetMarkFunction(lnod_id, CST_LEON_FIELD_id, FieldsFK ) Then
              fb_setFieldType(ADBSources, ADBSource, Aff_field, lnod_ClassProperties, lnod_id,lnod_import,ls_group, ls_tab,ldoc_ClassTemplate,ldoc_ClassImport,Aff_field.Index,lfc_DoFormCreate,cxRecurseTables in acx_CreateFromXML,nil, False);
            FreeAndNil(ldoc_ClassTemplate);
            FreeAndNil(ldoc_ClassImport);
            fb_GetMarkFunction(lnod_id, CST_LEON_FIELD_main, FieldsDisplay );
            inc ( li_CountFields );
          End;
      End;

begin
  laxd_Document := TALXMLDocument.Create ( Application );
  try
    ls_ProjectFile := fs_getProjectDir ( ) + as_Table + CST_LEON_File_Extension;
    Result := FileExistsUTF8 ( ls_ProjectFile );
    if Result Then
      try
        if fb_LoadXMLFile ( laxd_Document, ls_ProjectFile ) Then
         with laxd_Document do
          Begin
            lfwt_Source2 := nil;
            lnod_NodeCrossLink := nil;
            lb_Column := False;
            for li_i := 0 to ChildNodes.Count -1 do
              Begin
                lnod_Node := ChildNodes [ li_i ];
                ls_table:='';
                if not assigned ( lnod_NodeCrossLink )
                // search cross link node
                and fb_GetCrossLinkNode(as_FunctionClep,lnod_Node ) Then
                  lnod_NodeCrossLink := lnod_Node;
                if lnod_Node.NodeName = CST_LEON_CLASS then
                 with arel_Relation do
                  Begin
                    for li_j := 0 to lnod_Node.ChildNodes.Count -1 do
                      Begin
                        lnod_ClassProperties := lnod_Node.ChildNodes [ li_j ];
                        if (  ( lnod_ClassProperties.NodeName = CST_LEON_CLASS_C_BIND)
                            or (( lnod_ClassProperties.NodeName = CST_LEON_FIELDS ) and ( ls_table = '')))  then
                          Begin
                           if ( lnod_ClassProperties.NodeName = CST_LEON_CLASS_C_BIND) Then
                            ls_table:=trim(lnod_ClassProperties.Attributes [ CST_LEON_VALUE ]);
                           if ls_table='' Then
                             ls_table:=as_Table;
                           if cxRecurseTables in acx_CreateFromXML
                            Then
                            Begin
                             lfwt_Source2 := ADBSources.TableByName(ls_table);
                             if lfwt_Source2 = nil
                              Then
                               Begin // not found : create every tables
                                //      MyShowMessage(ls_Table + ' relation');
                                lfwt_Source2 := ADBSources.Add;
                                with lfwt_Source2 do
                                 Begin
                                  Table:= ls_table;
                                  TableXML:= fs_GetNodeAttribute(lnod_Node,CST_LEON_ID);
                                    IsMain := True;
                                 end;
                               end
                               // found : recreate uneeded
                              Else lfwt_Source2 := nil;
                            End;
                           // create relation table
                           lfwt_Source := TablesDest.Add;
                           with lfwt_Source do
                            Begin
                              Table:= ls_table;
                              TableXML:= fs_GetNodeAttribute(lnod_Node,CST_LEON_ID);
                              if cxCreateDS in acx_CreateFromXML Then
                               Begin
                                if lnod_ClassProperties.Attributes [ CST_LEON_LOCATION ] = Null
                                 Then lds_Connection:=DMModuleSources.fds_FindConnection( '', True )
                                 Else lds_Connection:=DMModuleSources.fds_FindConnection( lnod_ClassProperties.Attributes [ CST_LEON_LOCATION ], True );
                                with lds_Connection do
                                  Datasource := fds_CreateDataSourceAndTable ( Table, '_' +IntToStr ( ADBSource.Index ) +'_' + IntToStr ( arel_Relation.Index )+'_' + IntToStr ( Aff_field.Index ),
                                                       IntToStr ( ADBSource.index ), DatasetType, QueryCopy, acom_Owner);
                               end;
                            end;
                           as_Table:=ls_table;
                          end;
                        if  ( lnod_ClassProperties.NodeName = CST_LEON_FIELDS ) then
                         p_SetFields;
                      End;
                  End;
              End;
          End;
      Except
        On E: Exception do
          Begin
            MyShowMessage ( 'Error : ' + E.Message );
          End;
      End;
  finally
    laxd_Document.Destroy;
  end;
end;



function fnod_GetFieldNode ( const anod_Fields : TALXMLNode;
                             const as_SearchedNode : String):TALXMLNode;
var li_k : LongInt ;
begin
   // reading the special XML form File
   for li_k := 0 to anod_Fields.ChildNodes.Count-1 do
    with anod_Fields do
      if ChildNodes [ li_k ].Attributes[CST_LEON_ID] = as_SearchedNode Then
        Begin
         Result:=ChildNodes [ li_k ];
         Exit;
        End;

end;

function fnod_GetFieldNode ( const axml_Root : TALXMLDocument;
                             const as_SearchedNode : String):TALXMLNode;
var li_j : LongInt ;
begin
   // reading the special XML form File
  with axml_Root do
  for li_j := 0 to ChildNodes.Count -1 do
   Begin
    if ChildNodes [ li_j ].Attributes[CST_LEON_ID] = as_SearchedNode Then
      Begin
       Result:=ChildNodes [ li_j ];
       Exit;
      End;
   end;
end;

function ff_GetTemplateField ( const afws_ATables : TFWTables;
                               const afws_ATable : TFWTable;
                               const as_FieldName : String;
                               const anod_Fields, anod_Field: TALXMLNode;
                               var  anod_Template : TALXMLNode ) : TFWFieldColumn;
var lcx_FormCreate : TDoCreateFromXML;
    li_Fieldcounter : Integer;
    lnod_import : TALXMLNode;
    ldoc_ClassTemplate,
    ldoc_ClassImport : TALXMLDocument;
Begin
 with afws_ATable.FieldsDefs do
  Begin
   Result := FieldByName(as_FieldName);
   if Result = nil
    Then
     Begin
      li_Fieldcounter := 0;
      lcx_FormCreate := [cxFieldFound];
      ldoc_ClassTemplate := nil;
      ldoc_ClassImport := nil;
      p_OnCreateFieldProperties ( afws_ATables, afws_ATable, anod_Fields, anod_Template, lnod_import,ldoc_ClassImport, lcx_FormCreate, li_Fieldcounter );
      FreeAndNil(ldoc_ClassImport);
      FreeAndNil(ldoc_ClassTemplate);
      Result := Items [ Count - 1 ];
      Result.ColLocal:=True;
     end;
  end;

end;

function fnod_GetFieldNode ( const axml_Class : TALXMLDocument ;
                             var   anod_Fields : TALXMLNode;
                             const as_SearchedNode : String):TALXMLNode;
var li_i, li_j : LongInt ;
    lnod_Node, lnod_ClassNode : TALXMLNode ;
begin
   // reading the special XML form File
    try
      for li_i := 0 to axml_Class.ChildNodes.Count -1 do
        Begin
          lnod_Node := axml_Class.ChildNodes [ li_i ];
          if ( lnod_Node.NodeName = CST_LEON_CLASS  )
          or ( lnod_Node.NodeName = CST_LEON_STRUCT ) then
           Begin
              // reading the special XML form File
             for li_j := 0 to lnod_Node.ChildNodes.Count -1 do
              Begin
               lnod_ClassNode:=lnod_Node.ChildNodes [ li_j ];
               if ( lnod_ClassNode.NodeName = CST_LEON_FIELDS  )
               and lnod_ClassNode.HasChildNodes then
                Begin
                 anod_Fields:=lnod_ClassNode;
                 Result := fnod_GetFieldNode ( lnod_ClassNode, as_SearchedNode );
                End;
              end;
           end;
        End;
    finally
    End ;
end;

// function ft_CreateFormComponents
// Create a form from XML File
// as_XMLFile : XML File
// as_Name : Name of form
// awin_Parent : Parent component
// ai_Counter : The column counter for other XML File
function ft_CreateComponents ( const ADBSources : TFWTables ;
                               const as_XMLClass, as_Name : String ;
                               var   axml_Class : TALXMLDocument ;
                               const acom_owner : TComponent;
                               const ae_OnFieldNode : TOnExecuteFieldNode ;
                               const ae_onActionNode : TOnExecuteActionNode ;
                               const ae_onClassNameNode : TOnExecuteNode;
                               const acx_CreateFromXML : TDoCreateFromXML=[cxCreateDS];
                               const ab_ContinueIfLocal : Boolean = False;
                               const as_SearchedClass : String = ''):TFWTable;
var li_i, li_j, li_k, li_NoField : LongInt ;
    lnod_Node, lnod_ClassNode, lnod_Field, lnod_FieldImport : TALXMLNode ;
    ldoc_ClassImport : TALXMLDocument;
    lcx_FormCreate : TDoCreateFromXML;
    lb_Table : Boolean ;
    lb_Loaded : Boolean;
  // procedure p_CreateXMLColumn
  // Creates the XML form column
  // as_Table : Table name
  // as_Connection : Connection name
  procedure p_CreateXMLColumn ( const as_Table, as_TableXML, as_Connection : String );
  Begin
    Result := ADBSources.TableByName(as_Table);
    if not Assigned(Result) or (ADBSources.TableByName(as_Table).FieldsDefs.Count =0) or ( as_SearchedClass > '' ) Then
       Begin
       // MyShowMessage(as_Table + ' xmlcolumn');
        Result := ffws_CreateSource ( ADBSources, as_Connection, as_Table, as_Connection, acom_owner, as_TableXML );
        Result.IsMain:=True;
       end
      Else
       Result := ADBSources.TableByName(as_Table);
  end;

begin
  axml_Class := nil;
  Result := nil;
  lb_Loaded := fb_OpenClass ( as_XMLClass, acom_owner, axml_Class );
  if not lb_Loaded Then
     Exit;
   // reading the special XML form File
    try
      li_NoField := 0;
      lcx_FormCreate := acx_CreateFromXML;
      for li_i := 0 to axml_Class.ChildNodes.Count -1 do
        Begin
          lnod_Node := axml_Class.ChildNodes [ li_i ];
          if ( lnod_Node.NodeName = CST_LEON_CLASS  )
          or (( lnod_Node.NodeName = CST_LEON_STRUCT ) and (lb_Loaded or (lnod_Node.Attributes [ CST_LEON_ID ] = as_XMLClass))) then
            Begin
              if not (cxFieldFound in acx_CreateFromXML) Then
                Begin
                  lb_Table:=False;
                  for li_j := 0 to lnod_Node.ChildNodes.Count -1 do
                    Begin
                      lnod_ClassNode:=lnod_Node.ChildNodes [ li_j ];
                      if lnod_ClassNode.NodeName = CST_LEON_CLASS_C_MARKS Then
                       if not ab_ContinueIfLocal Then
                         if lnod_ClassNode.HasAttribute(CST_LEON_FIELD_LOCAL)
                         and (lnod_ClassNode.Attributes[CST_LEON_FIELD_LOCAL]=CST_LEON_BOOL_TRUE)
                          Then
                           Exit;

                      if lnod_ClassNode.NodeName = CST_LEON_CLASS_C_BIND Then
                       with lnod_ClassNode do
                        Begin
                          if ( as_SearchedClass > '' )
                          and ( Attributes [ CST_LEON_VALUE ] <> as_SearchedClass ) Then
                            Exit;
                          if ( as_SearchedClass > '' )
                          or (ADBSources.TableByName(Attributes [ CST_LEON_VALUE ]) = nil)
                           Then p_CreateXMLColumn (Attributes [ CST_LEON_VALUE ], lnod_Node.Attributes [ CST_LEON_ID ], Attributes [ CST_LEON_LOCATION ]);
                          if ( as_SearchedClass > '' )
                           Then Exit;
                          if assigned ( Result )
                           Then lb_Table := True
                           Else Exit;
                          Break;
                        end;
                    end;
                  if not lb_Table Then
                    p_CreateXMLColumn ( lnod_Node.Attributes [ CST_LEON_ID ], lnod_Node.Attributes [ CST_LEON_ID ], '' );
                end;
              if  not Assigned(ae_onActionNode)
              and not Assigned(ae_onClassNameNode)
              and not Assigned(ae_OnFieldNode) Then
                Exit;
              for li_j := 0 to lnod_Node.ChildNodes.Count -1 do
               Begin
                lnod_ClassNode:=lnod_Node.ChildNodes [ li_j ];
                with lnod_ClassNode do
                if ( NodeName = CST_LEON_FIELDS  )
                and HasChildNodes then
                 Begin
                   for li_k := 0 to ChildNodes.Count-1 do
                    Begin
                      lnod_Field := ChildNodes [ li_k ];
                      if Assigned(ae_OnFieldNode) Then
                       Begin
                        ldoc_ClassImport := nil;

                        ae_OnFieldNode ( ADBSources,Result, lnod_ClassNode, lnod_Field, lnod_FieldImport, ldoc_ClassImport, lcx_FormCreate, li_NoField);
                        FreeAndNil(ldoc_ClassImport);
                       end;
                    End;
                 end;
                 if ( lnod_ClassNode.NodeName = CST_LEON_ACTIONS  ) Then
                   if Assigned(ae_onActionNode) Then
                    ae_onActionNode ( ADBSources, Result, lnod_ClassNode, lcx_FormCreate );
                 if ( lnod_ClassNode.NodeName = CST_LEON_NAME  ) Then
                   if Assigned(ae_onClassNameNode) Then
                    ae_onClassNameNode ( ADBSources, Result, lnod_ClassNode, lnod_ClassNode, lcx_FormCreate, li_NoField );
               end;
            End;
        End;
    finally
    End ;
end;

// function fnod_FindField
// Find a node from XML File
// as_XMLClass : XML File
function fnod_FindField      ( const as_XMLClass : String ;
                               const acom_owner : TComponent;
                               var   axml_Class : TALXMLDocument ;
                               const as_SearchedField : String ):TALXMLNode;
var li_i, li_j, li_k, li_NoField : LongInt ;
    lnod_Node, lnod_ClassNode, lnod_Field : TALXMLNode ;
    lcx_FormCreate : TDoCreateFromXML;
    lb_Table : Boolean ;
    lb_Loaded : Boolean;

begin
  Result := nil;
  if axml_Class = nil Then
   Begin
     lb_Loaded := fb_OpenClass ( as_XMLClass, acom_owner, axml_Class );
     if not lb_Loaded Then
        Exit;
   end;
   // reading the special XML form File
    try
      li_NoField := 0;
      for li_i := 0 to axml_Class.ChildNodes.Count -1 do
        Begin
          lnod_Node := axml_Class.ChildNodes [ li_i ];
          if ( lnod_Node.NodeName = CST_LEON_CLASS  )
          or (( lnod_Node.NodeName = CST_LEON_STRUCT ) and (lb_Loaded or (lnod_Node.Attributes [ CST_LEON_ID ] = as_XMLClass))) then
            Begin
              for li_j := 0 to lnod_Node.ChildNodes.Count -1 do
               Begin
                lnod_ClassNode:=lnod_Node.ChildNodes [ li_j ];
                with lnod_ClassNode do
                if ( NodeName = CST_LEON_FIELDS  )
                and HasChildNodes then
                 Begin
                   for li_k := 0 to ChildNodes.Count-1 do
                    Begin
                      lnod_Field := ChildNodes [ li_k ];
                      if lnod_Field.HasAttribute ( CST_LEON_ID )
                      and ( lnod_Field.Attributes [ CST_LEON_ID ] = as_SearchedField ) Then
                       Begin
                        Result := lnod_Field;
                        Exit;
                       end;
                    End;
                 end;
               end;
            End;
        End;
    finally
    End ;
end;

// procedure p_setNodeField
// set TFWTable Field name
function fb_setNodeField ( const anod_Field : TALXMLNode;
                           const affd_ColumnFieldDef : TFWMiniFieldColumn;
                           var   acx_FormCreate:TDoCreateFromXML;
                           const ab_isreference : Boolean = True;
                           const ab_idref : Boolean = True;
                           const ab_Templates : Boolean = False):Boolean;
Begin
  Result:=False;
   with affd_ColumnFieldDef,anod_Field do
    Begin
      if HasAttribute(CST_LEON_NAME) Then
        Caption := fs_GetLabelCaption(Attributes [CST_LEON_NAME]);
      if (cxTemplateClass in acx_FormCreate)
      and HasAttribute(CST_LEON_TEMPLATE)
      and ab_Templates
      Then
       Begin
        FieldName := Attributes [CST_LEON_TEMPLATE];
        Result:=True;
        Exit;
       End;
      if not Result
      and ab_idref Then
       Begin
        Result:=HasAttribute(CST_LEON_IDREF);
        if Result Then
         Begin
          acx_FormCreate:=acx_FormCreate+[cxTemplateClass];
          if ab_isreference Then
            FieldName := Attributes [CST_LEON_IDREF];
         End;
       end;
      if not Result Then
       Begin
        Result:=HasAttribute(CST_LEON_ID);
        if (ab_isreference and Result)
         Then FieldName := Attributes [CST_LEON_ID]
       end;
    End;
end;

// procedure p_setNodeField
// set TFWTable Field name
procedure p_setNodesField ( const anod_FieldProperty : TALXMLNode;
                            const affd_ColumnFieldDef : TFWMiniFieldColumn;
                            const ab_isreference : Boolean = True);
Begin
  if Assigned ( affd_ColumnFieldDef ) Then
  with affd_ColumnFieldDef,anod_FieldProperty do
   Begin
      if NodeName=CST_LEON_NAME Then
        Caption := fs_GetLabelCaption(Attributes [CST_LEON_VALUE]);
      if ab_isreference and (NodeName = CST_LEON_FIELD_F_BIND) Then
        FieldName := Attributes [CST_LEON_VALUE];
    End;
end;

// procedure p_setNodeField
// set TFWTable Field name
function fb_getNodesField ( const anod_FieldProperty : TALXMLNode;
                            const ab_isreference : Boolean = True):Boolean;
Begin
  Result := anod_FieldProperty.NodeName = CST_LEON_FIELD_F_BIND;
end;

// procedure p_setNodeId
// set TFWTable key
procedure p_setNodeId ( const anod_FieldIsId : TALXMLNode;
                        const afws_Source : TFWTable ;
                        const affd_ColumnFieldDef : TFWMiniFieldColumn );
Begin
  with affd_ColumnFieldDef do
   if assigned ( afws_Source )
   and anod_FieldIsId.HasAttribute ( CST_LEON_ID )
   and not ( anod_FieldIsId.Attributes [ CST_LEON_ID ] = CST_LEON_BOOL_FALSE )
   and (afws_Source.GetKey.FieldByName(FieldName)=nil)
    then
     with afws_Source.GetKey.Add do
      Begin
       FieldName := affd_ColumnFieldDef.FieldName;
      end;
end;


////////////////////////////////////////////////////////////////////////////////
// function fs_GetIdAttribute
// get id or idref attribute of node
// anode : a node with id or idref
// Result : ID or IDREF Attribute
////////////////////////////////////////////////////////////////////////////////
function fs_GetIdAttribute ( const anode : TALXMLNode ) : String;
Begin
  if anode.HasAttribute(CST_LEON_ID)
   Then Result := anode.Attributes[CST_LEON_FIELD_ID]
   Else Result := anode.Attributes[CST_LEON_IDREF]
end;


////////////////////////////////////////////////////////////////////////////////
// procedure p_setFieldDefs
// getting CSV definitions and adding them from file
// adat_Dataset : CSV dataset
// alis_NodeFields : node of field nodes
////////////////////////////////////////////////////////////////////////////////


// function fs_LeonFilter
// special words replacing
// AString : Leon string
function fs_LeonFilter ( const AString : String ): String;
Begin
  Result := fs_RemplaceChar(AString,{$IFDEF WINDOWS}'/'{$ELSE}'\'{$ENDIF},DirectorySeparator);
  Result := StringReplace ( Result, CST_LEON_DOC+DirectorySeparator, fs_getLeonDir, [rfReplaceAll] );
  Result := StringReplace ( Result, CST_LEON_DOC, fs_getLeonDir, [rfReplaceAll] );
  Result := StringReplace ( Result, CST_LEON_DOC_DIR+DirectorySeparator, fs_getLeonDir, [rfReplaceAll] );
  Result := StringReplace ( Result, CST_LEON_DOC_DIR, fs_getLeonDir, [rfReplaceAll] );
  Result := StringReplace ( Result, CST_LEON_DIR+DirectorySeparator, fs_getLeonDir, [rfReplaceAll] );
  Result := StringReplace ( Result, CST_LEON_DIR, fs_getLeonDir, [rfReplaceAll] );

End;

// procedure fb_GetMarkFunction
// Getting field marks
// anod_Field : Node Field
// as_MarkSearched : Mark searched
// aano_IdNodes : List to add scruted field node
function fb_GetMarkFunction(const anod_Field :TALXMLNode ; const as_MarkSearched : String ; const aff_FieldNodes : TFWMiniFieldColumns ):Boolean;
var lnod_FieldProperties  ,
    lnod_FieldPropertiesTemp : TALXMLNode ;
    lff_Field : TFWMiniFieldColumn;
    lcxTemplateClass:TDoCreateFromXML;
    li_i : Integer ;
Begin
  Result:=False;
  lnod_FieldPropertiesTemp:=nil;
  if anod_Field.HasChildNodes then
    for li_i := 0 to anod_Field.ChildNodes.Count -1 do
      Begin
        lnod_FieldProperties := anod_Field.ChildNodes [ li_i ];
        if fb_getNodesField(lnod_FieldProperties) Then
         Begin
          lnod_FieldPropertiesTemp:=lnod_FieldProperties;
          if Assigned(aff_FieldNodes.FieldByName(lnod_FieldPropertiesTemp.Attributes[CST_LEON_VALUE])) Then
           Exit;
         end;
        if lnod_FieldProperties.NodeName = CST_LEON_FIELD_F_MARKS then
          Begin
            if (lnod_FieldPropertiesTemp=nil)
            and Assigned(aff_FieldNodes.FieldByName(anod_Field.Attributes[CST_LEON_ID])) Then
              Exit;
            if lnod_FieldProperties.HasAttribute ( as_MarkSearched )
            and ( lnod_FieldProperties.Attributes [ as_MarkSearched ] <> CST_LEON_BOOL_FALSE )
            and (  not lnod_FieldProperties.HasAttribute ( CST_LEON_FIELD_LOCAL )
                  or ( lnod_FieldProperties.Attributes [ CST_LEON_FIELD_LOCAL ] = CST_LEON_BOOL_FALSE )) then
             Begin
               lff_Field := aff_FieldNodes.Add;
               if Assigned(lnod_FieldPropertiesTemp) Then
                p_setNodesField(lnod_FieldPropertiesTemp,lff_Field);
               lcxTemplateClass := [];
               fb_setNodeField(anod_Field,lff_Field,lcxTemplateClass);
               Result:=True;
             end;
            Break;
          End;
      End;
End;

procedure p_FindAndSetSourceKey ( const as_Class, as_FieldExternalKey : String ;
                                  const afws_Sources : TFWTables ;
                                  const afws_Source : TFWTable ;
                                  const acom_owner : TComponent ;
                                  const ach_FieldDelimiter : Char );
var  li_k, li_l, li_m, li_n : Longint;
    lnod_NodeClass, lnod_Field, lnod_FieldsTemp,
    lnod_FieldProperty, lnod_Import      : TALXMLNode ;
    lfd_Fielddef : TFWFieldColumn;
    ldoc_ClassTemplate,
    ldoc_ClassImport,
    lxdoc_Document : TALXMLDocument;
    ls_group, ls_tab : String;
    lb_isrelation : Boolean;
    lcxTemplateClass : TDoCreateFromXML;
Begin
  lxdoc_Document := nil;
  lnod_FieldsTemp := nil;
  lnod_Import := nil;
  If fb_OpenClass ( as_class, acom_owner, lxdoc_Document ) Then
    try
   // reading the special XML form File
      for li_k := 0 to lxdoc_Document.ChildNodes.Count -1 do
        Begin
          lnod_NodeClass := lxdoc_Document.ChildNodes [ li_k ];
          if ( lnod_NodeClass.NodeName = CST_LEON_CLASS  )
          or ( lnod_NodeClass.NodeName = CST_LEON_STRUCT ) then
              for li_l := 0 to lnod_NodeClass.ChildNodes.Count -1 do
                Begin
                  lnod_Field := lnod_NodeClass.ChildNodes [ li_l ];
                  if lnod_Field.NodeName = CST_LEON_FIELDS Then
                   for li_m := 0 to lnod_Field.ChildNodes.Count -1 do
                     Begin
                       lnod_FieldProperty := lnod_Field.ChildNodes [ li_m ];
                       if fb_getNodesField(lnod_FieldProperty) Then
                         lnod_FieldsTemp:=lnod_FieldProperty;
                       with lnod_FieldProperty do
                       if HasChildNodes Then
                        for li_n := 0 to lnod_FieldProperty.ChildNodes.Count -1 do
                          if ( ChildNodes [ li_n ].NodeName = CST_LEON_FIELD_F_MARKS  ) then
                           try
                             ldoc_ClassTemplate := nil;
                             ldoc_ClassImport := nil;
                             lb_isrelation :=False;
                             lfd_Fielddef:=afws_Source.FieldsDefs.Add;
                             lcxTemplateClass := [cxMainOnly];
                             fb_setNodeField(lnod_Field,lfd_Fielddef,lcxTemplateClass);
                             if assigned(lnod_FieldsTemp)Then
                              p_setNodesField(lnod_FieldsTemp,lfd_Fielddef);
                             fb_setFieldType(afws_Sources,afws_Source,lfd_Fielddef,lnod_Field,lnod_FieldProperty,lnod_Import,ls_group, ls_tab,ldoc_ClassTemplate,ldoc_ClassImport,li_m,lcxTemplateClass,False,acom_owner,lb_isrelation);
                             p_setNodeId ( ChildNodes [ li_n ], afws_Source, lfd_Fielddef );
                           finally
                             FreeAndNil(ldoc_ClassImport);
                             FreeAndNil(ldoc_ClassTemplate);
                           end;
                     end;
                end;
        end;
    finally
      lxdoc_Document.Destroy;
    end;
End;

// search for relation and recursive create
function fb_FieldTypeRelation ( const afws_Source : TFWTable ;
                                var   afr_Relation : TFWRelation;
                                var   ata_table : TFWTable ;
                                var   as_FieldLink : String;
                                const anod_Field,anod_FieldProperties : TALXMLNode;
                                const af_FieldDef : TFWFieldColumn;
                                const acx_createFromXML: TDoCreateFromXML;
                                const ab_FullTable : Boolean;
                                const acom_Owner : TComponent):Boolean;
var lnod_FieldProperties : TALXMLNode;
    li_i : Integer;
    ls_ClassLink : String;
    ls_FieldLink : String;
    li_count : Integer;
    lt_Table : TFWTable;
  procedure p_SetFieldFromField ( const as_NewFieldName : String; const AfF_FieldSource, AfF_FieldDest : TFWFieldColumn );
    Begin
      AfF_FieldDest.Assign(AfF_FieldSource);
      with AfF_FieldDest do
       Begin
        FieldName  :=as_NewFieldName;
        ColUnique:=true;
        ColMain:=true;
       End;
      ata_table.GetKey.Add.FieldName:=as_NewFieldName;
    end;
  procedure p_AddTable ( const as_ClassLink : String );
  Begin
    lt_Table := (afws_Source.Collection as TFWTables).TableByNameXML(as_ClassLink);
    with afr_Relation do
    if (Assigned(ata_table) and ( as_FieldLink > '' ))
    and assigned ( lt_Table ) Then
     Begin
      TablesDest.Add.Table:=lt_Table.Table;
       Begin
        FieldsFK.Add.FieldName:=as_FieldLink;
        p_SetFieldFromField(as_FieldLink,lt_Table.FieldsDefs.FieldByName(lt_Table.Key [ 0 ].FieldName), ata_table.FieldsDefs.Add );
       End;
     end
    else
     if Reverse Then
      Begin
        // always added ?
       if not assigned ( lt_Table ) Then
        Begin
         fb_GetCrossLinkFunction( afws_Source.Collection as TFWTables,afws_Source, af_FieldDef,'', as_ClassLink, afr_Relation, [cxRecurseTables], acom_Owner );
        End;
      End;
  End;
Begin
  if ( anod_Field.NodeName = CST_LEON_RELATION )
    Then Result:=True
    Else
     Begin
      Result:=False;
      Exit;
     End;

  if assigned ( afr_Relation )
  and ((Assigned(ata_table) and ( as_FieldLink > '' )) or afr_Relation.Reverse )
  and (anod_FieldProperties.NodeName = CST_LEON_CLASSES) Then
  with afr_Relation do
   Begin
     ls_ClassLink := fs_GetNodeAttribute( anod_FieldProperties, CST_LEON_IDREFs );
     if ls_ClassLink = '' Then
      Begin
       for li_i := 0 to anod_FieldProperties.ChildNodes.Count-1 do
         Begin
           lnod_FieldProperties := anod_FieldProperties.ChildNodes [ li_i ];
           if lnod_FieldProperties.NodeName = CST_LEON_CLASS_REF Then
            Begin
             ls_ClassLink := fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_IDREF );
             p_AddTable ( ls_ClassLink );
            End;
         End;
      End
     else
      begin
        p_AddTable ( ls_ClassLink );
      End;
   end;

  // when there is no datasource created and no SQL table creation
//  if not ab_createDS and not ab_FullTable then
//   Exit; //quit bcause not needed
  // miltiple fields relation
  if ( anod_FieldProperties.NodeName = CST_LEON_RELATION_REVERSE) Then
   Begin
     afr_Relation := afws_Source.Relations.Add;
     with afr_Relation do
       Begin
         Reverse:=True;
         FieldsFK.Add.FieldName := fs_GetNodeAttribute(anod_FieldProperties, CST_LEON_REVERSE_RELATION );
       end;
   end;

  if ( anod_FieldProperties.NodeName = CST_LEON_RELATION_JOIN )
  Then
   Begin
    Ata_Table := nil;
    li_count := 0;
    with afws_Source.Collection as TFWTables do
    for li_i := 0 to anod_FieldProperties.ChildNodes.Count-1 do
      Begin
        lnod_FieldProperties := anod_FieldProperties.ChildNodes [ li_i ];
        if lnod_FieldProperties.NodeName = CST_LEON_CLASS_C_BIND Then
         Begin
           afr_Relation := afws_Source.Relations.Add;
           // grouping table
           with afr_Relation do
             Begin
               ls_ClassLink := fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_VALUE );
               Ata_Table:=TableByName(ls_ClassLink);
               if Ata_Table = nil then
                Begin
                  Ata_Table:=Add;
                  Ata_Table.Table:=ls_ClassLink;
                  if anod_FieldProperties.HasAttribute(CST_LEON_TEMPLATE)
                   Then Ata_Table.TableXML:=fs_GetNodeAttribute(anod_FieldProperties, CST_LEON_TEMPLATE)
                   Else Ata_Table.TableXML:=fs_GetNodeAttribute(anod_FieldProperties, CST_LEON_ID);
                end;
               // table can be on other database
               ls_ClassLink:=fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_LOCATION );
               if (ls_ClassLink > '')
               and assigned ( Ata_Table )
                Then Ata_Table.Connection:=DMModuleSources.fds_FindConnection( ls_ClassLink, True )
                Else Ata_Table.Connection:=afws_Source.Connection;
             end;
         end;
        with afr_Relation do
         Begin
           // ordered relation fields
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_F_BIND Then
            Begin
              // Get classes bindes relationships
              ls_ClassLink := fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_CLASS_CBIND );
              ls_FieldLink := fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_VALUE );
              inc (li_count);
              if assigned ( ata_table ) Then
               Begin
                if ( ata_table.FieldsDefs.FieldByName(ls_FieldLink) = nil)
                and (afws_Source.GetKey.Count > 0 ) Then
                 Begin
                  if TablesDest.indexOf(ata_table.Table) = -1 Then
                   Begin
                    FieldsFK.Add.FieldName:=ls_FieldLink;
                    with afws_Source do
                      p_SetFieldFromField ( ls_FieldLink, FieldsDefs.FieldByName(Key [ 0 ].FieldName), ata_table.FieldsDefs.Add );
                    TablesDest.Add.Table:=ata_table.Table;
                   end
                  else as_FieldLink:=ls_FieldLink;
                 End;
               end
            end;
         End;
      end;

   end;

  if  ( anod_FieldProperties.NodeName = CST_LEON_NAME )
  Then
   Begin
     if afr_Relation = nil Then
      afr_Relation := af_FieldDef.Relation;
     afr_Relation.Caption:=fs_GetLabelCaption(anod_FieldProperties.Attributes[CST_LEON_VALUE]);
   end;

  if (  ( anod_FieldProperties.NodeName = CST_LEON_CLASSES )
     or ( anod_FieldProperties.NodeName = CST_LEON_CLASS ))
  and ( afr_Relation.TablesDest.Count = 0 )
   Then
    Begin
     // Getting other class
      ls_ClassLink := fs_GetDBClassLink ( anod_FieldProperties  );
      fb_GetCrossLinkFunction( afws_Source.Collection as TFWTables,afws_Source, af_FieldDef,'', ls_ClassLink, afr_Relation, [cxMainOnly] * acx_createFromXML, acom_Owner );
   End;
end;

function fs_GetDBClassLink ( anod_FieldClassId : TALXMLNode ) : String;
var lnod_FieldProperties : TALXMLNode;
    li_i : Integer;
Begin
     // Getting other class
  Result := fs_GetNodeAttribute( anod_FieldClassId, CST_LEON_IDREFs );
  if ( Result = '' ) then
    Result := fs_GetNodeAttribute( anod_FieldClassId, CST_LEON_IDREF );
  // Getting the class finally
  if ( Result = '' )
  and anod_FieldClassId.HasAttribute(CST_LEON_TEMPLATE)
    Then Result := fs_GetNodeAttribute( anod_FieldClassId, CST_LEON_TEMPLATE );
  if ( Result = '' ) and anod_FieldClassId.HasChildNodes then
   for li_i := 0 to anod_FieldClassId.ChildNodes.Count-1 do
     Begin
       lnod_FieldProperties := anod_FieldClassId.ChildNodes [ li_i ];
       if lnod_FieldProperties.NodeName = CST_LEON_CLASS_REF Then
        Begin
          Result:=fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_IDREF );
          Exit;
        end;
       if lnod_FieldProperties.NodeName = CST_LEON_CLASSES Then
        Begin
          Result:=fs_GetNodeAttribute( lnod_FieldProperties, CST_LEON_IDREFs );
          Exit;
        end;
     end;
End;
// retrieve each properties of fields XML Node
// Return True if relationships found
function fb_FieldProperties ( const anod_Field,anod_FieldProperties : TALXMLNode;
                              var   as_formula  : String;
                              var ab_islarge : Boolean;
                              const af_FieldDef : TFWFieldColumn):Boolean;
var ldo_Temp : Double;
Begin
  Result := True;
  with af_FieldDef,anod_FieldProperties do
   Begin
     // recursive ended here for XML Form : Need only near tables
    Result:=False;
    if ( NodeName = CST_LEON_FIELD_DECIMALS )then
      Begin
       Decimals:=StrToInt(Attributes[CST_LEON_VALUE]);
       Exit;
      end;
    if ( NodeName = CST_LEON_FIELD_FORMULA )then
      Begin
       af_FieldDef.ColLocal:=True;
       as_formula :=Attributes[CST_LEON_VALUE];
       Exit;
      end;
    if ( NodeName = CST_LEON_FIELD_NROWS )
    or ( NodeName = CST_LEON_FIELD_NCOLS ) then
     Begin
      ab_IsLarge := True;
      Exit;
     end;
    if NodeName = CST_LEON_FIELD_NCHARS then
     Begin
      FieldLength := StrToInt(Attributes [ CST_LEON_VALUE ]);
       if FieldLength < 256 Then
        ab_islarge:=False;
      Exit;
     end;
    if NodeName = CST_LEON_FIELD_MAX then
       Begin
         if ( anod_Field.NodeName = CST_LEON_FIELD_TEXT ) then
           try
             FieldLength := StrToInt(Attributes [ CST_LEON_VALUE ]);
           Except
           end
         else
           if ( anod_Field.NodeName = CST_LEON_FIELD_NUMBER ) then
           try
             FieldLength:= Length ( Attributes [ CST_LEON_VALUE ]);
           Except
           end;
         try
           FieldSize := Trunc ( ldo_Temp );
         Except
         end;
         if FieldLength < 256 Then
          ab_islarge:=False;
        Exit;
       End;
     if ( NodeName = CST_LEON_NAME ) then
      Begin
       Caption := fs_GetLabelCaption(Attributes[CST_LEON_VALUE]);
       Exit;
      end;
     if NodeName = CST_LEON_FIELD_MIN then
       Begin
         if ( anod_Field.NodeName = CST_LEON_FIELD_TEXT ) then
           try
            FieldLength := StrToInt(Attributes [ CST_LEON_VALUE ]);
           Except
           end
         else
           if ( anod_Field.NodeName = CST_LEON_FIELD_NUMBER ) then
           try
            FieldLength:= Length ( Attributes [ CST_LEON_VALUE ]);
           Except
           end;
         if FieldLength < 256 Then
          ab_islarge:=False;
         Exit;
       End;
   end;
  Result := False;
End;

// retrieve each properties of fields XML Node
// Return True if relationships found
function fb_FieldTypeProperties ( const afws_Source : TFWTable ;
                                  var   afr_Relation : TFWRelation;
                                  var   ata_tableRelation : TFWTable ;
                                  var   as_FieldLink, as_Group, as_tab : String;
                                  const anod_Field,anod_FieldProperties : TALXMLNode;
                                  const af_FieldDef : TFWFieldColumn; var ab_islarge : Boolean;
                                  var   as_formula  : String;
                                  const acx_createFromXML: TDoCreateFromXML;
                                  const ab_FullTable : Boolean;
                                  const acom_Owner : TComponent):Boolean;
var ldo_Temp : Double;
Begin
  if anod_FieldProperties.NodeName = CST_LEON_GROUP then
   as_Group:=anod_FieldProperties.Attributes[CST_LEON_VALUE];
  if anod_FieldProperties.NodeName = CST_LEON_TAB then
   as_tab:=anod_FieldProperties.Attributes[CST_LEON_VALUE];
  if  fb_FieldTypeRelation ( afws_Source, afr_Relation, ata_tableRelation, as_FieldLink,anod_Field, anod_FieldProperties, af_FieldDef, acx_createFromXML, ab_FullTable, acom_Owner ) Then
   Begin
    Result:=True;
    Exit;
   end;
  Result := False;
  fb_FieldProperties(anod_Field,anod_FieldProperties,as_formula,ab_islarge,af_FieldDef);
End;

procedure p_SetValuesToFieldDefs ( const af_FieldDef : TFWFieldColumn;
                                   const anod_Field : TALXMLNode;
                                   const afws_Source : TFWTable ;
                                   const afr_Relation : TFWRelation;
                                   const as_fieldname   : String;
                                   var   acx_CreateFromXML : TDoCreateFromXML;
                                   var ab_local,ab_islarge : Boolean;
                                   const ab_passIfNotId : Boolean );
Begin
  if anod_Field.HasAttribute(CST_LEON_FIELD_NOCONTEXT)
  and ( anod_Field.Attributes[CST_LEON_FIELD_NOCONTEXT] = CST_LEON_BOOL_TRUE ) Then
   Begin
    ab_local := True;
   End;
     // relation field set by relation's table
  with af_FieldDef, anod_Field do
   Begin
    if assigned( afr_Relation )
     Then
      Begin
       acx_CreateFromXML:=acx_CreateFromXML+[cxIsRelation];
       ab_local:=af_FieldDef.ColLocal;
       Exit;
      End;
    acx_CreateFromXML:=acx_CreateFromXML-[cxIsRelation];

    if ab_passIfNotId and (afws_Source.GetKey.indexOf(as_FieldName) = -1)
     Then Exit;
    // data type of field
    FieldType := ftString;
    ab_isLarge:=False;
    if ( NodeName = CST_LEON_FIELD_NUMBER ) then
     begin
       if  HasAttribute(CST_LEON_FIELD_TYPE)
       and ( Attributes [ CST_LEON_FIELD_TYPE ] = CST_LEON_FIELD_DOUBLE )
        Then FieldType := ftFloat
        Else FieldType := ftInteger;
     end
    else if NodeName = CST_LEON_FIELD_FILE then
      Begin
        FieldType := ftString;
        Options:=Options+[foFile];
        FieldLength:=100;
      End
    else if NodeName = CST_LEON_FIELD_DATE then
      Begin
        FieldType := ftDate;
      End
    else if NodeName = CST_LEON_FIELD_CHOICE then
      Begin
        FieldType := ftString;
        Options:=Options+[foChoice];
        FieldLength:=1;
      End;
    // after setting the choice component setting the height
    if NodeName = CST_LEON_FIELD_TEXT then
      Begin
        if ab_isLarge Then
          Begin
            FieldType := ftMemo;
          End
         Else
          Begin
            FieldType := ftString;
            ColSelect:=True;
          End
      End;
  End;
End;
////////////////////////////////////////////////////////////////////////////////
// fonction p_setFieldType
// creating CSV definition properties
// Création de la définition de champ pour les fichiers CSV
// anod_Field : Field node
// afd_FieldsDefs : CSV definitions to add definition
// Result : local
////////////////////////////////////////////////////////////////////////////////
function  fb_setFieldType ( const afws_Sources : TFWTables ;
                            const afws_Source : TFWTable ;
                            const af_FieldDef : TFWFieldColumn;
                            const anod_Fields : TALXMLNode;
                            const anod_Field : TALXMLNode;
                            var   anod_FieldImport : TALXMLNode;
                            var   as_Group, as_tab : String;
                            var   adoc_ClassTemplate,adoc_ClassImport : TALXMLDocument ;
                            const ai_counter : Integer;
                            var   acx_CreateFromXML : TDoCreateFromXML;
                            const ab_FullTable : Boolean;
                            const acom_Owner : TComponent;
                            const ab_isreference : Boolean=True;
                            const ab_passIfNotId : Boolean = False;
                            const as_fieldname   : String = ''): Boolean;
var lb_isLarge : Boolean ;
    li_k : Integer;
    lnod_Prop : TALXMLNode;
    lfr_Relation : TFWRelation;
    lta_table : TFWTable;
    ls_field : String;
    ls_formula : String;
begin
  Result:=False;
  lfr_Relation := nil;
  lta_table := nil;
  ls_field := '';
  anod_FieldImport := nil;
  with af_FieldDef, anod_Field do
   Begin
    if HasChildNodes then
     for li_k := 0 to ChildNodes.Count -1 do
      Begin
        lnod_Prop:=ChildNodes [ li_k ];
        // type properties of field
        ls_Formula := '';
        fb_FieldTypeProperties ( afws_Source, lfr_Relation, lta_table, ls_field,as_Group, as_tab, anod_Field,lnod_Prop, af_FieldDef, lb_isLarge, ls_Formula, acx_CreateFromXML,ab_FullTable,acom_Owner);

        // options like local
        Result := fb_getFieldOptions ( afws_Sources, afws_Source, anod_Fields, anod_Field,anod_FieldImport,adoc_ClassTemplate,adoc_ClassImport,lnod_Prop,af_FieldDef,acom_Owner,ab_isreference,cxMainOnly in acx_CreateFromXML,ab_FullTable) and (cxMainOnly in acx_CreateFromXML);
        if ls_formula > '' Then
          Begin
           af_FieldDef.Formula:=ls_formula;
           Result := True;
          End
      End;
    End;
  if assigned(anod_FieldImport ) Then
   Begin
    p_SetValuesToFieldDefs ( af_FieldDef,anod_FieldImport, afws_Source,
                             lfr_Relation, as_fieldname, acx_CreateFromXML,
                             Result, lb_islarge, ab_passIfNotId );
    af_FieldDef.ColLocal:=True;
    Result := True;
   End
  Else
   p_SetValuesToFieldDefs ( af_FieldDef,anod_Field, afws_Source,
                            lfr_Relation, as_fieldname, acx_CreateFromXML,
                            Result, lb_islarge, ab_passIfNotId );

end;
procedure p_CreateStructTable( const afwt_Sources : TFWTables; const aft_Table : TFWTable;
                               const affd_ColumnFieldDef  : TFWFieldColumn;
                               var acx_FormCreate : TDoCreateFromXML ;
                               var   ai_Fieldcounter : Longint  );
var li_j : LongInt ;
    LField : TFWMiniFieldColumn;
    lnod_Field : TALXMLNode;
Begin
   for li_j := 0 to gxdo_RootXML.ChildNodes.Count - 1 do
      Begin
         lnod_Field := gxdo_RootXML.ChildNodes [ li_j ];
         if (lnod_Field.NodeName= CST_LEON_STRUCT)
         and (fs_GetIdAttribute( lnod_Field ) = aft_Table.TableXML)
         and fb_CreateArrayStructComponents(afwt_Sources, aft_Table, affd_ColumnFieldDef, lnod_Field,
                                        acx_FormCreate, ai_Fieldcounter )
         Then
          Begin
           if assigned ( affd_ColumnFieldDef ) Then
            Begin
             fb_setNodeField (lnod_Field,affd_ColumnFieldDef,acx_FormCreate);
             p_FieldIsNotAKey( affd_ColumnFieldDef );
            end;
          end;

      end;

   if assigned (affd_ColumnFieldDef)
   and (aft_Table.GetKey.Count> 0) Then
     Begin
      LField := aft_Table.GetKey.Items [0];
      affd_ColumnFieldDef.Assign(aft_Table.FieldsDefs.FieldByName(LField.FieldName));
     end;
End;


function fb_getOptionalStructTable ( const afwt_Sources : TFWTables;
                                     const afwt_Source : TFWTable;
                                     var   afwt_Source2 : TFWTable;
                                     var   ac_FormCreate : TDoCreateFromXML ;
                                     var   ai_Fieldcounter : Longint  ;
                                     const affd_ColumnFieldDef : TFWFieldColumn;
                                     const anod_Field,anod_OriginalNode : TALXMLNode;
                                     const ab_createDS : Boolean ; const ab_AddLinks : Boolean ): Boolean;
var li_k : LongInt ;
    lnod_FieldsNode : TALXmlNode;
    LField : TFWMiniFieldColumn;
    ls_Table, ls_TableXML, ls_base : String ;
    lcx_SearchTable : TDoCreateFromXML;
Begin
  Result:=fb_getOptionalStructTableBegin ( afwt_Sources,
                                     afwt_Source, afwt_Source2,
                                     ac_FormCreate,
                                     ai_Fieldcounter,
                                     affd_ColumnFieldDef,
                                     anod_Field,anod_OriginalNode,
                                     ab_createDS, ab_AddLinks);
   if not Result Then Exit;
   lcx_SearchTable := ac_FormCreate-[cxTemplateClass];
   p_CreateStructTable( afwt_Sources, afwt_Source2,
                         affd_ColumnFieldDef,
                         lcx_SearchTable,
                         ai_Fieldcounter );
  if ab_AddLinks then p_LinkTables ( afwt_Source, afwt_Source2 );
End;


function fb_getOptionalStructTableBegin ( const afwt_Sources : TFWTables;
                                     const afwt_Source : TFWTable;
                                     var   afwt_Source2 : TFWTable;
                                     var   afc_FormCreating : TDoCreateFromXML ;
                                     var   ai_Fieldcounter : Longint  ;
                                     const affd_ColumnFieldDef : TFWFieldColumn;
                                     const anod_Class,anod_OriginalNode : TALXMLNode;
                                     const ab_createDS : Boolean ; const ab_AddLinks : Boolean ): Boolean;
var li_k : LongInt ;
    lnod_FieldsNode : TALXmlNode;
    LField : TFWMiniFieldColumn;
    ls_Table, ls_TableXML, ls_base : String ;
Begin
  Result:=False;
  ls_Table:=anod_Class.Attributes[CST_LEON_TEMPLATE];
   if anod_OriginalNode.HasChildNodes then
     for li_k := 0 to anod_OriginalNode.ChildNodes.Count - 1 do
       Begin
         lnod_FieldsNode := anod_OriginalNode.ChildNodes [ li_k ];
         if lnod_FieldsNode.NodeName = CST_LEON_CLASS_C_BIND Then
          Begin
           Result:=True;
           ls_Table:=lnod_FieldsNode.Attributes[CST_LEON_VALUE];
           ls_TableXML:=anod_Class.Attributes[CST_LEON_TEMPLATE];
           ls_base :=lnod_FieldsNode.Attributes[CST_LEON_LOCATION];
           Break;
          end;
       end;
   Result := not assigned(afwt_Sources.TableByName(ls_Table));
   if not Result Then Exit;
   if  ( ls_base = '')
   and ( ab_createDS ) Then
    ls_base:=afwt_Source.Connection.PrimaryKey;
   afwt_Source2 := ffws_CreateSource( afwt_Sources, ls_base, ls_Table, Null, afwt_Sources.Owner as TComponent, ls_TableXML, ab_createDS );
   afwt_Source2.IsMain := True;
End;

// Function fb_getFieldImport
// setting some data properties
// Result : quitting
function fb_getFieldImport  ( const afws_Sources : TFWTables;
                              const afws_Source : TFWTable;
                              const anod_Fields : TALXMLNode;
                              var   anod_FieldImport : TALXMLNode ;
                              var   adoc_ClassTemplate,adoc_ClassImport : TALXMLDocument ;
                              const anod_FieldProperties : TALXMLNode;
                              const acom_Owner : TComponent ): Boolean;
var ls_Relation,ls_fieldImport,ls_classLink : String;
    li_i : Integer;
    lnod_Relation,
    lnod_anode : TALXMLNode ;
begin
  Result := False;
  if anod_FieldProperties.HasAttribute ( CST_LEON_FIELD_relation ) Then
   Begin
     ls_Relation := anod_FieldProperties.Attributes [ CST_LEON_FIELD_relation ];
     ls_fieldImport := anod_FieldProperties.Attributes [ CST_LEON_IDREF ];
     lnod_Relation:=nil;
     for li_i := 0 to anod_Fields.ChildNodes.Count - 1 do
      Begin
        lnod_anode := anod_Fields.ChildNodes [ li_i ];
        if lnod_anode.HasAttribute ( CST_LEON_ID )
        and ( lnod_anode.Attributes [ CST_LEON_ID ] =  ls_Relation )
         Then Begin
               lnod_Relation := lnod_anode;
               Break;
              end;
      end;
     if assigned ( lnod_Relation ) Then
      try
       ls_classLink := fs_GetDBClassLink ( lnod_Relation );
       anod_FieldImport   := fnod_FindField  ( ls_classLink, nil, adoc_ClassImport, ls_fieldImport );
       if anod_FieldImport = nil
        Then
         Begin
          if adoc_ClassTemplate = nil Then
           ft_FindTableOrigin(afws_Source,afws_Sources,acom_Owner,adoc_ClassTemplate);
          anod_FieldImport   := fnod_FindField  ( afws_Source.Table, nil, adoc_ClassTemplate, ls_classLink );
         end;
       Result := True;
      finally
      end;
   end;

end;


// Function fb_getFieldOptions
// setting some data properties
// Result : quitting
function fb_getFieldOptions ( const afws_Sources : TFWTables;
                              const afws_Source : TFWTable;
                              const anod_Fields : TALXMLNode;
                              const anod_Field  : TALXMLNode ;
                              var   anod_FieldImport : TALXMLNode ;
                              var   adoc_ClassTemplate,adoc_ClassImport : TALXMLDocument ;
                              const anod_FieldProperties : TALXMLNode ;
                              const affd_ColumnFieldDef : TFWFieldColumn;
                              const acom_Owner : TComponent;
                              const ab_isReference : Boolean = True ;
                              const ab_MainOnly : Boolean = False ;
                              const ab_FullTable : Boolean = False): Boolean;
begin
  Result := False;
  with anod_FieldProperties, affd_ColumnFieldDef do
   Begin
     if NodeName = CST_LEON_FIELD_F_MARKS then
       Begin
        ColMain  := False;
        if HasAttribute ( CST_LEON_FIELD_LOCAL )
        and ( Attributes [ CST_LEON_FIELD_LOCAL ] <> CST_LEON_BOOL_FALSE )  then
          Begin
           ColSelect:=False;
           ColLocal:=True;
          End
         Else
          ColLocal:=False;
        Result := not ColLocal;
        if HasAttribute ( CST_LEON_FIELD_main)
         then
           ColSelect:=Attributes [ CST_LEON_FIELD_main ] = CST_LEON_BOOL_TRUE;

        if ab_MainOnly Then
         Result := ColSelect;

       if ab_isReference then
        Begin
         if HasAttribute ( CST_LEON_FIELD_CREATE)
          then ColCreate  := Attributes [ CST_LEON_FIELD_CREATE ] = CST_LEON_BOOL_TRUE;
         if HasAttribute ( CST_LEON_FIELD_PROVIDER)
          then ColCreate  := Attributes [ CST_LEON_FIELD_PROVIDER ] = CST_LEON_BOOL_TRUE;
         if HasAttribute ( CST_LEON_FIELD_UNIQUE)
          then ColUnique  := Attributes [ CST_LEON_FIELD_UNIQUE ] = CST_LEON_BOOL_TRUE;
         if HasAttribute ( CST_LEON_FIELD_id)
          then ColUnique  := Attributes [ CST_LEON_FIELD_id ] = CST_LEON_BOOL_TRUE;
         if HasAttribute ( CST_LEON_FIELD_private)
          then ColPrivate  := Attributes [ CST_LEON_FIELD_private ] = CST_LEON_BOOL_TRUE;
         p_setNodeId(anod_FieldProperties,afws_Source,affd_ColumnFieldDef);
         if ( HasAttribute ( CST_LEON_FIELD_sort)
            and ( Attributes [ CST_LEON_FIELD_sort ] = CST_LEON_BOOL_TRUE ))
         or ( HasAttribute ( CST_LEON_FIELD_find)
              and ( Attributes [ CST_LEON_FIELD_find ] = CST_LEON_BOOL_TRUE ))  then
           Begin
             ShowSearch := affd_ColumnFieldDef.Index + 1;
           End
          Else
           ShowCol := affd_ColumnFieldDef.Index + 1
        end;

       if HasAttribute ( CST_LEON_FIELD_hidden )
       and not ( Attributes [ CST_LEON_FIELD_hidden ] = CST_LEON_BOOL_FALSE )  then
         Begin
           ShowCol := -1;
           ShowSearch := -1;
           ColHidden:=True;
           Exit;
         End;
       ShowCol := affd_ColumnFieldDef.Index + 1;
       if HasAttribute ( CST_LEON_FIELD_set )
       and (   ( Attributes [ CST_LEON_FIELD_set  ] = CST_LEON_BOOL_TRUE )
            or ( Attributes [ CST_LEON_FIELD_main ] = CST_LEON_BOOL_TRUE ))  then
         Begin
           ColMain  := True;
         End;
       if HasAttribute ( CST_LEON_FIELD_optional )
       and ( Attributes [ CST_LEON_FIELD_optional  ] = CST_LEON_BOOL_TRUE )  then
         Begin
           ColOption := True;
         End;
      End;
     if ( NodeName = CST_LEON_FIELD_IMPORT ) Then
      Begin
       if not ab_FullTable then
        Begin
          if HasAttribute ( CST_LEON_FIELD_relation ) Then
           Begin
             fb_getFieldImport ( afws_Sources, afws_Source, anod_Fields, anod_FieldImport, adoc_ClassTemplate, adoc_ClassImport,  anod_FieldProperties, acom_Owner );
           end;
        end
       Else // Needed to build database correctly
        anod_FieldImport:=anod_Field;
      end;
     p_setNodesField(anod_FieldProperties,affd_ColumnFieldDef,ab_isReference);
    End;

end;

// procedure fb_GetMarkFunction
// Getting field marks
// anod_Field : Node Field
// as_MarkSearched : Mark searched
// aano_IdNodes : List to add scruted field node
procedure p_CountMarkFunction(const anod_Field :TALXMLNode ; const as_MarkSearched : String ; const ab_IsTrue : Boolean; var ai_Count : Integer );
var lnod_FieldProperties : TALXMLNode ;
    li_i : Integer ;
Begin
  if anod_Field.HasChildNodes then
    for li_i := 0 to anod_Field.ChildNodes.Count -1 do
      Begin
        lnod_FieldProperties := anod_Field.ChildNodes [ li_i ];
        if lnod_FieldProperties.NodeName = CST_LEON_FIELD_F_MARKS then
          Begin
            if  (  ab_IsTrue
                   and       lnod_FieldProperties.HasAttribute ( as_MarkSearched )
                   and not ( lnod_FieldProperties.Attributes [ as_MarkSearched ] = CST_LEON_BOOL_FALSE ))
                or (( not lnod_FieldProperties.HasAttribute ( as_MarkSearched )
                       or ( lnod_FieldProperties.Attributes [ as_MarkSearched ] = CST_LEON_BOOL_FALSE )
                           and not ab_IsTrue )) Then
                inc ( ai_Count );
            Break;
          End;
      End;
End;

// function fb_GetCrossLinkNode
// getting other side relationships
// as_ParentClass : Orginal class name
// anod_FieldProperties : Node field properties

function fb_GetCrossLinkNode( const as_ParentClass: String ; const anod_FieldProperties :TALXMLNode ): Boolean ;
var lnod_ClassesProperties : TALXMLNode ;
    li_j : Integer;
Begin
  Result := False;
  if ( anod_FieldProperties.NodeName = CST_LEON_CLASSES )
  and anod_FieldProperties.HasChildNodes then
    for li_j :=  0 to anod_FieldProperties.ChildNodes.Count -1 do
    Begin
      lnod_ClassesProperties := anod_FieldProperties.ChildNodes [ li_j ];
      if lnod_ClassesProperties.NodeName = CST_LEON_CLASS_REF  then
        Begin
          if ( as_ParentCLass = '' )
          or ( anod_FieldProperties.Attributes [ CST_LEON_IDREF ] = as_ParentCLass ) Then
            Begin
              Result := True;
            end;
        End;
    End
  else if ( anod_FieldProperties.NodeName = CST_LEON_CLASS )
  and    (   ( as_ParentCLass = '' )
          or ( anod_FieldProperties.Attributes [ CST_LEON_IDREF ] = as_ParentCLass )) Then
    Begin
      Result := True;
    end;
End;

// function fs_GetNodeAttribute
// getting attribute of node
// anod_Node : A node
// as_Attribute : An attribute
function fs_GetNodeAttribute( const anod_Node : TALXMLNode ; const as_Attribute : String ) : String ;
begin
  if anod_Node.HasAttribute ( as_Attribute ) then
    Result := anod_Node.Attributes [ as_Attribute ]
   Else
    Result := '';
end;

// function fnod_GetClassFromRelation
// getting class from XML Node
// anod_Node : Node containing class node
function fnod_GetClassFromRelation( const anod_Node : TALXMLNode ) : TALXMLNode ;
var li_i : Integer ;
    lnod_Node : TALXMLNode;
begin

  Result := nil;
  for li_i := 0 to anod_Node.ChildNodes.Count -1 do
    Begin
      lnod_Node := anod_Node.ChildNodes [ li_i ];
      if ( lnod_Node.NodeName = CST_LEON_CLASSES )
      or ( lnod_Node.NodeName = CST_LEON_CLASS ) Then
        Result := lnod_Node;
    End;
end;

// function fnod_GetNodeFromIdRef
// getting node from idref attributes of node
// anod_Node : Node containing or not containing idref
function fnod_GetNodeFromTemplate( const anod_Node : TALXMLNode ) : TALXMLNode ;
var li_i : Integer ;
    lnod_Node : TALXMLNode;
    ls_Template : String;
begin

  Result := anod_Node;
  if ( anod_Node.Attributes [ CST_LEON_TEMPLATE ] <> Null ) Then
    Begin
      ls_Template := anod_Node.Attributes [ CST_LEON_TEMPLATE ];
      for li_i := 0 to gxdo_RootXML.ChildNodes.Count -1 do
        Begin
          lnod_Node := gxdo_RootXML.ChildNodes [ li_i ];
          if ( lnod_Node.Attributes[CST_LEON_ID] = ls_Template ) Then
            Begin
              Result := lnod_Node;
              Break;
            end;
        End;
    end;
end;

// function fs_getLeonInfo
// getting info directory

function fs_getLeonInfo : String;
Begin
  Result := fs_getLeonDir + 'info' + DirectorySeparator ;
End;

// function fs_getLeonDataXML
// getting data XML directory
function fs_getLeonDataXML : String;
Begin
  if gb_DataHasXML
   Then Result := fs_getLeonDir + 'data' + DirectorySeparator
   Else Result := fs_getLeonDir + 'info' + DirectorySeparator ;
End;

// function fs_getLeonData
// getting data directory
function fs_getLeonData : String;
Begin
  Result := fs_getLeonDir + 'data' + DirectorySeparator;
End;

// function fs_getLeonData
// getting data directory
function fs_getLeonDoc : String;
Begin
  Result := fs_getLeonDir;
End;

// function fs_getLeonFiles
// getting files directory
function fs_getLeonFiles : String;
Begin
  Result := fs_getLeonDir + 'files' + DirectorySeparator ;
End;

// function fs_getProjectDir
// getting main directory
function fs_getProjectDir : String;
Begin
  Result := ExtractFileDir ( fs_getLeonDir + gs_ProjectFile );
End;

// function fs_getImagesDir
// getting image directory
function fs_getImagesDir : String;
Begin
  Result := fs_getLeonDir + CST_IMAGES_DIR;
End;

// function fb_LoadXMLFile
// Loading XML File
// axdo_FichierXML : XML document loading
// as_FileXML : XML File Path to set
function fb_LoadXMLFile ( const axdo_FichierXML : TALXMLDocument; const as_FileXML : String ): Boolean;
  function fb_LoadXML (): Boolean;
    Begin
      if not FileExistsUTF8 ( as_FileXML ) Then
        Begin
          MyShowMessage ( 'File Not Found : ' + as_FileXML );
          Result := False;
          Exit;
        end;
      try
       axdo_FichierXML.LoadFromFile ( as_FileXML );
      Except
      End;
      Result := axdo_FichierXML.Active;
    End;
Begin
  Result := fb_LoadXML ();
End;

procedure p_SetFieldSelect ( const affd_ColumnFieldDef : TFWFieldColumn; const act_ComponentType : TComponentType  );
Begin
  affd_ColumnFieldDef.ColSelect:=act_ComponentType=ctDB;
end;

initialization
  GS_Data_Extension := '.res';
{$IFDEF VERSIONS}
  p_ConcatVersion ( gVer_fonctions_XML );
{$ENDIF}
finalization
  FreeAndNil(gxdo_RootXML);
end.
